#comments-start
	MadMACs from Irongeek and Glj12
	For more information on this code read the readme file or visit http://irongeek.com
	Consider this code GPLed
#comments-end
#RequireAdmin
#region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=icon.ico
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#endregion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <File.au3>
Global $mainkey = "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002bE10318}\"
;Begin Core Logic
;Yes, the below code is redundant, but I decided to err on the side of clarity over brevity.
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GuiComboBoxEx.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

Dim $option = StringLower($CmdLineRaw)
;$option= "doittoit"

Select
	Case $option = "remove"
		RemoveStartup()
	Case $option = "config" Or (Not FileExists(@ScriptDir & "\mac-config.txt"))
		ShowConfigGUI()
	Case $option = "doittoit"
		SetHostnameFromFileIfThere(@ScriptDir & "\dic.txt")
		SetMACUsingConfigFile(@ScriptDir & "\mac-config.txt")
		Exit
	Case Else
		ShowConfigGUI()
EndSelect
;End Core Logic

Func ShowConfigGUI()
	Global $MadMACSForm = GUICreate("MadMACs 2.0.1 - Irongeek.com", 605, 80, 192, 114)
	Global $NICCombo = GUICtrlCreateCombo("Choose Interface To Configure", 55, 8, 545, 25, BitOR($CBS_DROPDOWN, $CBS_AUTOHSCROLL))
	Global $ConfigInterfaceCheckbox = GUICtrlCreateCheckbox("Change default MAC address on this interface", 160, 32, 249, 17)
	Global $WirelessCheckbox = GUICtrlCreateCheckbox("Check if this is a WiFi NIC (or some problematic wired ones) under Vista/7/8 (2nd nibble randomly set to 2, 6, A or E)", 8, 56, 577, 17)
	Global $MACPrefixInput = GUICtrlCreateInput("00", 75, 32, 80, 21)
	$Label1 = GUICtrlCreateLabel("Interface:", 2, 8, 49, 17)
	$Label2 = GUICtrlCreateLabel("MAC or Prefix:", 2, 32, 71, 17)
	$SaveApplyButton = GUICtrlCreateButton("Save/Apply", 410, 35, 89, 17)
	$SetStartup = GUICtrlCreateButton("Run On Startup", 510, 35, 89, 17)
	GUISetState(@SW_SHOW)
	dim $driverdesc, $nicnum,$prefix ,$Wireless
	if RegRead("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Run", "RandMAC") then
		GUICtrlSetData($SetStartup,"Kill From Startup")
	EndIf
	PopulateComboBox()
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				Exit
			Case $NICCombo
				$tempArr = StringSplit(_GUICtrlComboBox_GetEditText($NICCombo)," ||| ",1)
				if $tempArr[0] = 2 Then
					$driverdesc =$tempArr[1]
					$nicnum = IniRead(@ScriptDir & "\mac-config.txt", $driverdesc, "nicnum", "")
					$prefix = IniRead(@ScriptDir & "\mac-config.txt", $driverdesc, "prefix", "00")
					$Wireless = MakeBool(IniRead(@ScriptDir & "\mac-config.txt", $driverdesc, "wireless", ""))
					GUICtrlSetData($MACPrefixInput,$prefix)
					If $nicnum <> "" Then
						GUICtrlSetState($ConfigInterfaceCheckbox, $GUI_CHECKED)
					Else
						GUICtrlSetState($ConfigInterfaceCheckbox, $GUI_UNCHECKED)
					EndIf
					If $Wireless Then
						GUICtrlSetState($WirelessCheckbox, $GUI_CHECKED)
					Else
						GUICtrlSetState($WirelessCheckbox, $GUI_UNCHECKED)
					EndIf
				Else
					GUICtrlSetData($MACPrefixInput,"00")
					GUICtrlSetState($ConfigInterfaceCheckbox, $GUI_UNCHECKED)
					GUICtrlSetState($WirelessCheckbox, $GUI_UNCHECKED)
				EndIf
			Case $SaveApplyButton
				If GUICtrlRead($ConfigInterfaceCheckbox) == $GUI_CHECKED Then
					$tempArr = StringSplit(_GUICtrlComboBox_GetEditText($NICCombo)," ||| ",1)
					if $tempArr[0]=2 Then
						$driverdesc =$tempArr[1]
						$nicnum=$tempArr[2]
						$prefix = GUICtrlRead($MACPrefixInput)
						$Wireless = MakeBool(GUICtrlRead($WirelessCheckbox))
						WriteToINI($driverdesc,$nicnum,$prefix,$Wireless)
					EndIf
				Else
					IniDelete(@ScriptDir & "\mac-config.txt", $driverdesc)
				EndIf
				SetHostnameFromFileIfThere(@ScriptDir & "\dic.txt")
				SetMACUsingConfigFile(@ScriptDir & "\mac-config.txt")
			case $SetStartup
					if RegRead("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Run", "RandMAC") = "" then
						GUICtrlSetData($SetStartup,"Kill From Startup")
						AddStartup()
					Else
						RemoveStartup()
						GUICtrlSetData($SetStartup,"Run On Startup")
					EndIf
		EndSwitch
	WEnd
EndFunc

Func WriteToINI($driverdesc,$nicnum,$prefix,$Wireless)
	IniWrite(@ScriptDir & "\mac-config.txt", $driverdesc, "nicnum", $nicnum)
	IniWrite(@ScriptDir & "\mac-config.txt", $driverdesc, "prefix", $prefix)
	IniWrite(@ScriptDir & "\mac-config.txt", $driverdesc, "wireless", $Wireless)
EndFunc

Func MakeBool($SomeString)
	if $SomeString="True" Then
		return True
	Elseif $SomeString=1 Then
		return True
	Else
		return False
	EndIf
EndFunc

Func PopulateComboBox()
	Dim $exit = 0, $i = 1, $tmp = 0
	While Not $exit
		$nicnum = RegEnumKey($mainkey, $i)
		If @error = -1 Then $exit = 1
		$bustype = RegRead($mainkey & $nicnum, "BusType")
		$driverdesc = RegRead($mainkey & $nicnum, "DriverDesc")
		If $bustype <> "" Then
			_GUICtrlComboBox_AddString($NICCombo, $driverdesc & " ||| " & $nicnum)
		EndIf
		$i = $i + 1
	WEnd
	Return 0
EndFunc   ;==>PopulateComboBox


Func SetMAC($nicid, $newmac)
	RegWrite($mainkey & $nicid, "NetworkAddress", "REG_SZ", $newmac)
	RunWait("wmic path win32_networkadapter where index=" & String(int($nicid)) & " call disable","",False)
	RunWait("wmic path win32_networkadapter where index=" & String(int($nicid)) & " call enable","",False)
EndFunc   ;==>SetMAC

Func MakeRandomMAC($Wireless, $MACPrefix)
	Dim $2ndNibble[4]
	$2ndNibble[0] = "2"
	$2ndNibble[1] = "6"
	$2ndNibble[2] = "A"
	$2ndNibble[3] = "E"
	$rmac = ""
	For $i = 1 To (12 - StringLen($MACPrefix))
		$rmac = $rmac & Hex(Random(0, 15, 1), 1)
	Next
	$TempMAC = $MACPrefix & $rmac
	If $Wireless And Not (StringMid($TempMAC, 2, 1) = "2" Or StringMid($TempMAC, 2, 1) = "6" Or StringMid($TempMAC, 2, 1) = "A" Or StringMid($TempMAC, 2, 1) = "E") Then
		$TempMAC = StringLeft($TempMAC, 1) & $2ndNibble[Random(0, 3, 1)] & StringLeft($TempMAC, 10)
	EndIf
	If $rmac <> "FFFFFFFFFFFF" Or "000000000000" Then
		Return $TempMAC
	Else
		Return MakeRandomMAC($Wireless, $MACPrefix)
	EndIf
EndFunc   ;==>MakeRandomMAC

Func SetMACUsingConfigFile($filename)
	If FileExists($filename) Then
		$INISectionList = IniReadSectionNames(@ScriptDir & "\mac-config.txt")
		if IsArray($INISectionList) then
			For $i = 1 To $INISectionList[0]
				;MsgBox(4096, "", $INISectionList[$i])
				$nicnum = IniRead(@ScriptDir & "\mac-config.txt", $INISectionList[$i], "nicnum", "")
				$prefix = IniRead(@ScriptDir & "\mac-config.txt", $INISectionList[$i], "prefix", "")
				$Wireless = IniRead(@ScriptDir & "\mac-config.txt", $INISectionList[$i], "wireless", "")
				If $Wireless = "True" Then
					$Wireless = True
				Else
					$Wireless = False
				EndIf
				SetMAC($nicnum, MakeRandomMAC($Wireless,$prefix))
			Next
		endif
	EndIf
EndFunc   ;==>SetMACUsingConfigFile

Func SetHostnameFromFileIfThere($filename)
	RemoveSettings() ; To get rid of old setting in registry
	If FileExists($filename) Then
		$maxlinecount = _FileCountLines($filename)
		$tmp = Random(0, $maxlinecount, 1)
		$hostname = FileReadLine($filename, $tmp)
		$hostname = StringLeft(StringRegExpReplace($hostname, "[^/a-zA-Z0-9_-]", ""), 15) ; Filter bad characters, and truncate to 15 characters
		RegWrite("HKEY_LOCAL_MACHINE\SYSTEM\ControlSet001\Control\ComputerName\ComputerName\", "ComputerName", "REG_SZ", $hostname)
		RegWrite("HKEY_LOCAL_MACHINE\SYSTEM\ControlSet001\Services\Tcpip\Parameters\", "NV Hostname", "REG_SZ", $hostname)
		RegWrite("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\ComputerName\ComputerName\", "ComputerName", "REG_SZ", $hostname)
		RegWrite("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tcpip\Parameters\", "NV Hostname", "REG_SZ", $hostname)
	EndIf
EndFunc   ;==>SetHostnameFromFileIfThere

Func AddStartup()
	RegWrite("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Run", "RandMAC", "REG_SZ", @AutoItExe & " doittoit")
	MsgBox(0, "", "Added to startup.")
EndFunc

Func RemoveStartup()
	RegDelete("HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Run", "RandMAC")
	RemoveSettings()
	MsgBox(0, "", "Deleted from startup and registry cleared.")
EndFunc

Func RemoveSettings()
	Dim $exit = 0, $i = 1, $ai = 0
	While Not $exit
		$nicnum = RegEnumKey($mainkey, $i)
		If @error = -1 Then $exit = 1
		$bustype = RegRead($mainkey & $nicnum, "BusType")
		$driverdesc = RegRead($mainkey & $nicnum, "DriverDesc")
		If $bustype <> "" Then
			RegDelete($mainkey & $nicnum, "NetworkAddress")
		EndIf
		$i = $i + 1
	WEnd
EndFunc   ;==>RemoveSettings
